package config

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/zrpc"
	"time"
)

type Config struct {
	zrpc.RpcServerConf
	// Redis Cluster
	Cache                   cache.CacheConf
	CacheExpireTime         time.Duration
	CacheWithNotFoundExpiry time.Duration
	
	Mongo struct {
		Schema                           string
		User                             string
		Password                         string
		Host                             string
		Port                             string
		Database                         string
		ReplicaName                      string
		MaxStaleness                     time.Duration
		MaxPoolSize                      uint64
		MinPoolSize                      uint64
		MaxConnIdleTime                  time.Duration
		Compressors                      []string
		EnableStandardReadWriteSplitMode bool
		ConnectTimeoutMs                 int64
	}
}
