package productlogic

import (
	"code.30cm.net/digimon/app-cloudep-product-service/pkg/domain/entity"
	"context"

	"code.30cm.net/digimon/app-cloudep-product-service/gen_result/pb/product"
	"code.30cm.net/digimon/app-cloudep-product-service/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type CreateCategoryLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewCreateCategoryLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CreateCategoryLogic {
	return &CreateCategoryLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// CreateCategory 建立 product 分類
func (l *CreateCategoryLogic) CreateCategory(in *product.CreateCategoryReq) (*product.OKResp, error) {
	err := l.svcCtx.CategoryUseCase.Insert(l.ctx, &entity.Category{
		Name: in.GetName(),
	})
	if err != nil {
		return nil, err
	}

	return &product.OKResp{}, nil
}
