package productlogic

import (
	"context"

	"code.30cm.net/digimon/app-cloudep-product-service/gen_result/pb/product"
	"code.30cm.net/digimon/app-cloudep-product-service/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetCategoryLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetCategoryLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetCategoryLogic {
	return &GetCategoryLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// GetCategory 取得 product 分類
func (l *GetCategoryLogic) GetCategory(in *product.CategoryReq) (*product.Category, error) {
	category, err := l.svcCtx.CategoryUseCase.FindOneByID(l.ctx, in.GetId())
	if err != nil {
		return nil, err
	}

	return &product.Category{
		Id:         category.ID.Hex(),
		Name:       category.Name,
		CreateTime: category.CreatedAt,
		UpdateTime: category.UpdatedAt,
	}, nil
}
