package repository

import (
	"context"

	"code.30cm.net/digimon/app-cloudep-product-service/pkg/domain/entity"

	"go.mongodb.org/mongo-driver/mongo"
)

// CategoryRepository 操作更多信息
type CategoryRepository interface {
	Insert(ctx context.Context, data *entity.Category) error
	FindOneByID(ctx context.Context, id string) (*entity.Category, error)
	Update(ctx context.Context, id string, data *entity.Category) (*mongo.UpdateResult, error)
	Delete(ctx context.Context, id string) (int64, error)
	ListCategory(ctx context.Context, params *CategoryQueryParams) ([]*entity.Category, int64, error)
	// IsCategoryExists 丟進去存在的再拿出來
	IsCategoryExists(ctx context.Context, ids []string) []string
}

type CategoryQueryParams struct {
	PageSize  int64 // 每頁顯示的專案數量
	PageIndex int64 // 要查詢的頁數
	ID        []string
}
